//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_color3  Gold
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern int    RsiPeriod       = 14;
extern int    RsiPrice        = PRICE_CLOSE;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = true;
extern bool   alertsEmail     = true;
extern string soundFile       = "alert2.wav"; 


//
//
//
//
//

double UpBuffer[];
double DnBuffer[];
double NuBuffer[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,UpBuffer); SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexLabel(0,"UpTrend");   SetIndexDrawBegin(0,RsiPeriod );
   SetIndexBuffer(1,DnBuffer); SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexLabel(1,"DownTrend"); SetIndexDrawBegin(1,RsiPeriod );
   SetIndexBuffer(2,NuBuffer); SetIndexStyle(2,DRAW_HISTOGRAM); SetIndexLabel(2,"NoTrend");   SetIndexDrawBegin(2,RsiPeriod );
   SetIndexBuffer(3,trend);    SetIndexEmptyValue(3,0);

   IndicatorShortName("RSI Filter("+RsiPeriod +")");
   return(0);
}

//

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,limit,countedBars = IndicatorCounted();

   if (countedBars<0) return(-1);
   if (countedBars>0) countedBars--;
         limit = MathMin(Bars-countedBars,Bars-1);
   
   //
   //
   //
   //
   //
   
   for(i = limit; i>=0; i--)
   {
      trend[i]    = trend[i+1];
      DnBuffer[i] = EMPTY_VALUE;
      UpBuffer[i] = EMPTY_VALUE;
      NuBuffer[i] = EMPTY_VALUE;
     
      //
      //
      //
      //
      //
           
      double RSI0 = iRSI(NULL,0,RsiPeriod,RsiPrice,i);
         if (RSI0>70) trend[i] =  1; 
         if (RSI0<30) trend[i] = -1;
	  
         if (trend[i]>0 && RSI0 > 40)                                UpBuffer[i] = 1; 
         if (trend[i]<0 && RSI0 < 60)                                DnBuffer[i] = 1;
         if (UpBuffer[i] == EMPTY_VALUE && DnBuffer[i]==EMPTY_VALUE) NuBuffer[i] = 1;
	  }
	  
	  //
	  //
	  //
	  //
	  //
	  
	  if (alertsOn)
     {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;
       
        if (UpBuffer[whichBar] != EMPTY_VALUE && UpBuffer[whichBar+1]==EMPTY_VALUE) doAlert("Buy");
        if (DnBuffer[whichBar] != EMPTY_VALUE && DnBuffer[whichBar+1]==EMPTY_VALUE) doAlert("Sell");  
     }
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

           message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," RsiFilter ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " RsiFilter  "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}